package com.zt.plat.module.qms.resource.device.service;

import com.zt.plat.framework.common.pojo.CommonResult;
import com.zt.plat.framework.common.pojo.PageResult;
import com.zt.plat.module.qms.resource.device.controller.vo.DeviceProductPageReqVO;
import com.zt.plat.module.qms.resource.device.controller.vo.DeviceProductRespVO;
import com.zt.plat.module.qms.resource.device.controller.vo.DeviceProductSaveReqVO;
import com.zt.plat.module.qms.resource.device.dal.dataobject.DeviceProductDO;
import jakarta.validation.Valid;

import java.util.List;

/**
 * 设备-设备大类 Service 接口
 *
 * @author 后台管理
 */
public interface DeviceProductService {

    //保存分类
    CommonResult<DeviceProductRespVO> saveCategory(@Valid DeviceProductSaveReqVO createReqVO);

    //保存数据
    CommonResult<DeviceProductRespVO> saveData(@Valid DeviceProductSaveReqVO createReqVO);

    /*获取分类树数据*/
    List<DeviceProductDO> getTreeData(String nodeType);

    List<Long> getIdListByIdPath(Long id);
    List<DeviceProductDO> listByIdPath(Long id, String nodeType);
    List<DeviceProductDO> listByParId(Long parId, String nodeType);

    CommonResult<String> updateAllIdPath(Long parentId, Integer level);

    /**
     * 创建设备-设备大类
     *
     * @param createReqVO 创建信息
     * @return 编号
     */
    DeviceProductRespVO createDeviceProduct(@Valid DeviceProductSaveReqVO createReqVO);

    /**
     * 更新设备-设备大类
     *
     * @param updateReqVO 更新信息
     */
    void updateDeviceProduct(@Valid DeviceProductSaveReqVO updateReqVO);

    /**
     * 删除设备-设备大类
     *
     * @param id 编号
     */
    void deleteDeviceProduct(Long id);

    /**
    * 批量删除设备-设备大类
    *
    * @param ids 编号
    */
    void deleteDeviceProductListByIds(List<Long> ids);

    /**
     * 获得设备-设备大类
     *
     * @param id 编号
     * @return 设备-设备大类
     */
    DeviceProductDO getDeviceProduct(Long id);

    /**
     * 获得设备-设备大类分页
     *
     * @param pageReqVO 分页查询
     * @return 设备-设备大类分页
     */
    PageResult<DeviceProductDO> getDeviceProductPage(DeviceProductPageReqVO pageReqVO);

    /**
     * 根据分类名获取设备大类
     *
     * @param deviceCategoryName 分类名称
     * @return 设备大类列表
     */
    List<DeviceProductDO> getDeviceProductByCategoryName(String deviceCategoryName);
}